const blocks = [
    { name: 'telekinesis:f_chest', model: 'chest', minecraftBlock: 'minecraft:chest' },
    { name: 'telekinesis:f_trapped_chest', model: 'trapped', minecraftBlock: 'minecraft:trapped_chest' },
    { name: 'telekinesis:f_ender_chest', model: 'ender', minecraftBlock: 'minecraft:ender_chest' },
    { name: 'telekinesis:f_shulker_box', model: 'shulker', minecraftBlock: 'minecraft:shulker_box' },
    { name: 'telekinesis:f_black_shulker_box', model: 'shulker_black', minecraftBlock: 'minecraft:black_shulker_box' },
    { name: 'telekinesis:f_blue_shulker_box', model: 'shulker_blue', minecraftBlock: 'minecraft:blue_shulker_box' },
    { name: 'telekinesis:f_brown_shulker_box', model: 'shulker_brown', minecraftBlock: 'minecraft:brown_shulker_box' },
    { name: 'telekinesis:f_cyan_shulker_box', model: 'shulker_cyan', minecraftBlock: 'minecraft:cyan_shulker_box' },
    { name: 'telekinesis:f_gray_shulker_box', model: 'shulker_gray', minecraftBlock: 'minecraft:gray_shulker_box' },
    { name: 'telekinesis:f_green_shulker_box', model: 'shulker_green', minecraftBlock: 'minecraft:green_shulker_box' },
    { name: 'telekinesis:f_light_blue_shulker_box', model: 'shulker_light_blue', minecraftBlock: 'minecraft:light_blue_shulker_box' },
    { name: 'telekinesis:f_light_gray_shulker_box', model: 'shulker_light_gray', minecraftBlock: 'minecraft:light_gray_shulker_box' },
    { name: 'telekinesis:f_lime_shulker_box', model: 'shulker_lime', minecraftBlock: 'minecraft:lime_shulker_box' },
    { name: 'telekinesis:f_magenta_shulker_box', model: 'shulker_magenta', minecraftBlock: 'minecraft:magenta_shulker_box' },
    { name: 'telekinesis:f_orange_shulker_box', model: 'shulker_orange', minecraftBlock: 'minecraft:orange_shulker_box' },
    { name: 'telekinesis:f_pink_shulker_box', model: 'shulker_pink', minecraftBlock: 'minecraft:pink_shulker_box' },
    { name: 'telekinesis:f_purple_shulker_box', model: 'shulker_purple', minecraftBlock: 'minecraft:purple_shulker_box' },
    { name: 'telekinesis:f_red_shulker_box', model: 'shulker_red', minecraftBlock: 'minecraft:red_shulker_box' },
    { name: 'telekinesis:f_white_shulker_box', model: 'shulker_white', minecraftBlock: 'minecraft:white_shulker_box' },
    { name: 'telekinesis:f_yellow_shulker_box', model: 'shulker_yellow', minecraftBlock: 'minecraft:yellow_shulker_box' }
];


function createStorageBlock(event, blockName, modelName, minecraftBlock) {
    event.create(blockName, 'cardinal').blockEntity(entityInfo => {
        entityInfo.inventory(9, 3);  
        entityInfo.rightClickOpensInventory();  
        entityInfo.serverTick(2, 1, entity => {
            const blockData = entity.block.entityData.attachments[0]["items"];
            entity.inventory.clear();  
            placeBlock(entity.x, entity.y, entity.z, minecraftBlock, blockData, entity.level);  
        });
    })
    .model(`telekinesis:block/${modelName}`)  
    .fullBlock(false)  
    .transparent(true)  
    .defaultCutout()  
    .tag('telekinesis:storage');  
}


StartupEvents.registry('block', event => {
    blocks.forEach(block => {
        createStorageBlock(event, block.name, block.model, block.minecraftBlock);
    });
});


StartupEvents.modifyCreativeTab('kubejs:tab', event => {
    blocks.forEach(block => {
        event.remove(block.name);  
    });
});

function placeBlock(x, y, z, id, item, level) {
    try {
        let block = level.getBlock(x, y, z)
        let props = block.properties
        block.set(id, props)
        block.setEntityData({ Items: item })
    } catch (e) { console.error(e); return e }
}