StartupEvents.registry('palladium:abilities', (event) => {
    event.create('telekinesis/sharing_slot4')

        .firstTick((player, entry, holder, enabled) => {
            const tags = player.tags
            if (enabled) {
                tags.add("telekinesis_boost_sharing_slot4")
                player.stages.add("telekinesis.boost.sharing.slot4")
                let target = getEntityByUUID(player.persistentData.telekinesisBoostSharingSlot4);
                if (target) {
                    if (player.isCrouching() && player.onGround()) {
                        global.playSoundLocal(player, 'minecraft:entity.villager.no', "players", 0.5, 2);
                        let nameToStage = target.username.toLowerCase().replace(/_/g, ".")
                        let slot4 = "slot4" + nameToStage
                        if (player.stages.has(slot4)) {
                            player.stages.remove(slot4)
                            player.tags.remove("telekinesis_sharing_slot4")
                            player.persistentData.telekinesisBoostSharingSlot4 = ""
                            player.persistentData.telekinesisBoostSharingSlot4Name = ""
                            resetAttributesAndTeam(target)
                        }
                    } else if (distanceBetween(player, target) <= 20) {
                        global.playSoundLocal(player, 'minecraft:block.enchantment_table.use', "players", 0.5, 1.5);
                        global.playSoundLocal(target, 'minecraft:block.enchantment_table.use', "players", 0.5, 1.5);
                        target.persistentData.telekinesisBoostSharingFrom = player.uuid.toString()
                        if(global.telekinesisConfig.generalGlowingEffect){
                            let targetTeam = target.teamId
                            if (targetTeam && targetTeam != "telekinesis") {
                                target.persistentData.telekinesisOldTeam = targetTeam;
                            }
                            let targetId = target.isPlayer() ? target.username : target.uuid;
                            target.server.runCommandSilent(`team join telekinesis ${targetId}`);
                            target.setGlowing(true);
                        }
                    }
                }

            } else {
                tags.remove("telekinesis_boost_sharing_slot4")
                player.stages.remove("telekinesis.boost.sharing.slot4")
            }
        })

        .tick((player, entry, holder, enabled) => {
            if (enabled) {
                const xp = "telekinesis.psy_xp";
                const energy = "telekinesis.psy_energy";
                let target = getEntityByUUID(player.persistentData.telekinesisBoostSharingSlot4);
                let psycoLevel = palladium.scoreboard.getScore(player, "telekinesis.psy_level", 1);
                let sharing1 = player.tags.contains("telekinesis_boost_toggle")
                let sharing2 = player.tags.contains("telekinesis_boost_sharing_slot5")
                let sharingValue = (sharing1 ? 1 : 0) + (sharing2 ? 1 : 0) + 1;

                if (target && target.persistentData.telekinesisBoostSharingFrom == player.uuid) {
                    if (distanceBetween(player, target) <= 20) {
                        applyAttributes(target, psycoLevel, sharingValue);
                        palladium.scoreboard.subtractScore(player, energy, 1);
                        if (palladium.scoreboard.getScore(player, energy) <= 0) {
                            palladium.scoreboard.setScore(player, energy, -1);
                        }

                        palladium.scoreboard.addScore(player, xp, 1);

                        player.persistentData.telekinesisEnergyCooldown = 40;

                        
                        target.resetFallDistance();

                    } else {
                        player.tags.add("telekinesis_sharing_slot4_re")
                        player.tags.remove("telekinesis_sharing_slot4")
                    }
                }else {
                    player.tags.add("telekinesis_sharing_slot4_re")
                    player.tags.remove("telekinesis_sharing_slot4")
                }
            }
        })

        .lastTick((player, entry, holder, enabled) => {
            if(enabled){
                let target = getEntityByUUID(player.persistentData.telekinesisBoostSharingSlot4);
                if (player.tags.contains("telekinesis_sharing_slot4_re")) {
                    player.tags.add("telekinesis_sharing_slot4")
                    player.tags.remove("telekinesis_sharing_slot4_re")
                }
                player.tags.remove("telekinesis_boost_sharing_slot4")
                player.stages.remove("telekinesis.boost.sharing.slot4")
                if (target) {
                    global.playSoundLocal(player, 'minecraft:block.enchantment_table.use', "players", 0.5, 1.5);
                    global.playSoundLocal(target, 'minecraft:block.enchantment_table.use', "players", 0.5, 1.5);
                    target.persistentData.telekinesisBoostSharingFrom = ""
                    resetAttributesAndTeam(target)
                } else{
                    player.tags.remove("telekinesis_sharing_slot4")
                }
            }
        });
});