const $ClientboundSetEntityMotionPacket = Java.loadClass('net.minecraft.network.protocol.game.ClientboundSetEntityMotionPacket');
const $ClipContext = Java.loadClass('net.minecraft.world.level.ClipContext')
const $ProjectileUtil = Java.loadClass('net.minecraft.world.entity.projectile.ProjectileUtil')
const $Registries = Java.loadClass('net.minecraft.core.registries.Registries')
const $TagKey = Java.loadClass('net.minecraft.tags.TagKey')
const banned_entities = $TagKey.create($Registries.ENTITY_TYPE, new ResourceLocation("telekinesis:banned_entities"));
const entityLvlTags = [
    $TagKey.create($Registries.ENTITY_TYPE, new ResourceLocation("telekinesis:lv1")),
    $TagKey.create($Registries.ENTITY_TYPE, new ResourceLocation("telekinesis:lv2")),
    $TagKey.create($Registries.ENTITY_TYPE, new ResourceLocation("telekinesis:lv3")),
    $TagKey.create($Registries.ENTITY_TYPE, new ResourceLocation("telekinesis:lv4")),
    $TagKey.create($Registries.ENTITY_TYPE, new ResourceLocation("telekinesis:lv5"))
];
const blockLvlTags = ["telekinesis:lv1", "telekinesis:lv2", "telekinesis:lv3", "telekinesis:lv4", "telekinesis:lv5"];
const chest = "telekinesis:chest"
const nonsolid = "telekinesis:nonsolid"
const banned_blocks = "telekinesis:banned_blocks"

StartupEvents.registry('palladium:abilities', (event) => {
    event.create('telekinesis/psyco_ability')

        .firstTick((player, entry, holder, enabled) => {
            if (enabled) {
                let result = rayTrace(player, 8, 1);
                let { entity: r_Entity, block: r_Block } = result;
                let entityData = r_Entity?.persistentData || null;
                let levelRequirements = null
                let psycoLevel = palladium.scoreboard.getScore(player, "telekinesis.psy_level", 1);

                
                if (r_Entity &&
                    !r_Entity.entityType.is(banned_entities) &&
                    !entityData?.telekinesisBoostSharingFrom &&
                    !r_Entity.tags.contains("telekinesis_boost_toggle")) {
                    player.stopRiding();
                    let { minX, maxX, minY, maxY, minZ, maxZ } = r_Entity.getBoundingBox();

                    
                    let volume = (maxX - minX) * (maxY - minY) * (maxZ - minZ);

                    

                    let entityHasTelekinesisTag = entityLvlTags.some(tag => {
                        
                        return r_Entity.entityType.is(tag);
                    });

                    let entityLevel = null;
                    let hasPsycoLevelForEntity = entityLvlTags.some((tag, index) => {
                        
                        entityLevel = index + 1; 

                        
                        return r_Entity.entityType.is(tag) && psycoLevel >= entityLevel;
                    });

                    
                    if (entityHasTelekinesisTag && hasPsycoLevelForEntity) {
                        entityTarget(player, r_Entity, entityLevel);
                    }
                    else if (entityHasTelekinesisTag && !hasPsycoLevelForEntity) {
                        global.playSoundLocal(player, 'minecraft:block.note_block.didgeridoo', "players", 1, 0.1)
                    }
                    else if (!entityHasTelekinesisTag) {
                        
                        levelRequirements = [
                            { maxVolume: 0.12, requiredLevel: 1 },
                            { maxVolume: 0.26, requiredLevel: 2 },
                            { maxVolume: 0.75, requiredLevel: 3 },
                            { maxVolume: 1.15, requiredLevel: 4 },
                            { maxVolume: Infinity, requiredLevel: 5 }
                        ];

                        
                        entityLevel = levelRequirements.find(req => volume <= req.maxVolume && psycoLevel >= req.requiredLevel)?.requiredLevel || 0;
                        if (entityLevel > 0) {
                            entityTarget(player, r_Entity, entityLevel);
                        } else {
                            global.playSoundLocal(player, 'minecraft:block.note_block.didgeridoo', "players", 1, 0.1)
                        }
                    }
                }
                
                else if (r_Block && !r_Block.hasTag(nonsolid) && !r_Block.hasTag(banned_blocks)) {

                    let blockState = r_Block.blockState
                    let destroySpeed = blockState.getDestroySpeed(player.level.getChunkAt(r_Block.pos), r_Block.pos)

                    
                    let hasTelekinesisTag = blockLvlTags.some(tag => r_Block.hasTag(tag));
                    let blockLevel = null

                    
                    let hasPsycoLevel = blockLvlTags.some((tag, index) => {
                        blockLevel = index + 1; 
                        return r_Block.hasTag(tag) && psycoLevel >= blockLevel; 
                    });

                    
                    if (hasTelekinesisTag && hasPsycoLevel) {
                        creatBlock(player, r_Block, blockLevel);
                    }
                    else if (hasTelekinesisTag && !hasPsycoLevel) {
                        global.playSoundLocal(player, 'minecraft:block.note_block.didgeridoo', "players", 1, 0.1)
                    }
                    
                    else if (!hasTelekinesisTag) {
                        
                        levelRequirements = [
                            { maxDestroySpeed: 0.9, requiredLevel: 1 },
                            { maxDestroySpeed: 2, requiredLevel: 2 },
                            { maxDestroySpeed: 3, requiredLevel: 3 },
                            { maxDestroySpeed: 4.5, requiredLevel: 4 },
                            { maxDestroySpeed: Infinity, requiredLevel: 5 }
                        ];

                        
                        blockLevel = levelRequirements.find(req => destroySpeed <= req.maxDestroySpeed && psycoLevel >= req.requiredLevel)?.requiredLevel || 0;

                        if (blockLevel > 0) {
                            creatBlock(player, r_Block, blockLevel);
                        } else {
                            global.playSoundLocal(player, 'minecraft:block.note_block.didgeridoo', "players", 1, 0.1)
                        }
                    }
                }
            } else {
                
                dataReset(player)
            }
        })

        .tick((player, entry, holder, enabled) => {
            if (enabled) {
                let target = getEntityByUUID(player.persistentData.telekinesisTarget);
                let f_Block_Targ = getEntityByUUID(player.persistentData.telekinesisBlockTarget);
                let requiredLevel = player.persistentData.telekinesisRequiredLevel;
                let playerIsTargetedBy = !!player.persistentData.telekinesisTargetedBy;

                
                if (player.deadOrDying || !player.mainHandItem.isEmpty() || playerIsTargetedBy || (target && distanceBetween(player, target) > 9)) {
                    if (f_Block_Targ) {
                        target.kill();
                        setGlowGrav(f_Block_Targ, false);  
                    } else if (target) {
                        if (target.isPlayer()) dataReset(target);
                        setGlowGrav(target, false);  
                    }
                    
                    target = f_Block_Targ = null;
                }

                
                if (target && !target.removed) {
                    
                    if (f_Block_Targ) {
                        f_Block_Targ.getServer().runCommandSilent(`team join telekinesis ${f_Block_Targ.uuid}`);
                        f_Block_Targ.mergeNbt({ Time: 0 });
                    }

                    
                    setGlowGrav(target, true);

                    
                    let targetId = target.isPlayer() ? target.username : target.uuid;
                    target.getServer().runCommandSilent(`team join telekinesis ${targetId}`);

                    

                    doMotion(player, target, f_Block_Targ);
                    palladium.scoreboard.subtractScore(player, "telekinesis.psy_energy", requiredLevel)
                    if (palladium.scoreboard.getScore(player, "telekinesis.psy_energy") <= 0) palladium.scoreboard.setScore(player, "telekinesis.psy_energy", -1)
                    palladium.scoreboard.addScore(player, "telekinesis.psy_xp", requiredLevel)

                    player.persistentData.telekinesisEnergyCooldown = 40

                } else {
                    
                    dataReset(player);
                }
            }
        })

        .lastTick((player, entry, holder, enabled) => {
            
            let target = getEntityByUUID(player.persistentData.telekinesisTarget);
            let f_Block_Targ = getEntityByUUID(player.persistentData.telekinesisBlockTarget);
            let distance = player.persistentData.psyco_scroll;
            let requiredLevel = player.persistentData.telekinesisRequiredLevel;
            let energyMax = palladium.scoreboard.getScore(player, "telekinesis.psy_energy_max")
            let playerLevel = palladium.scoreboard.getScore(player, "telekinesis.psy_level")
            let energy = palladium.scoreboard.getScore(player, "telekinesis.psy_energy")

            
            if (target) {
                
                if (!player.isCrouching() && energy > 0) {
                    const { yaw, pitch } = player;

                    
                    let { x, y, z } = calculateViewXYZ(pitch, yaw);

                    
                    const movementFactor = calculerForce(distance);
                    x *= movementFactor;
                    y *= movementFactor;
                    z *= movementFactor;

                    
                    if (f_Block_Targ) {
                        target.kill();  
                        setGlowGrav(f_Block_Targ, false);  
                        f_Block_Targ.setMotion(x, y, z);  
                        f_Block_Targ.tags.add("psyco_block_throw");  
                        f_Block_Targ.persistentData.telekinesisRequiredLevel = requiredLevel;
                        f_Block_Targ.persistentData.telekinesisThrowForce = movementFactor;
                        f_Block_Targ.playSound('minecraft:ui.toast.out', 2, 1)
                        global.playSoundLocal(player, 'minecraft:block.enchantment_table.use', "players", 0.5, 1.5);
                    } else {
                        
                        if (target.tags.contains("psyco_shield_drop")) {
                            target.removeTag("psyco_shield_drop");
                        }
                        if (target.persistentData.psyco_shield) {
                            target.persistentData.remove("psyco_shield");  
                        }
                        target.setNoGravity(false);  
                        target.setMotion(x, y, z);  
                        target.playSound('minecraft:ui.toast.out', 2, 1)
                        global.playSoundLocal(player, 'minecraft:block.enchantment_table.use', "players", 0.5, 1.5);
                        if (target.isPlayer()) {
                            target.connection.send(new $ClientboundSetEntityMotionPacket(target));
                        }
                    }
                    palladium.scoreboard.subtractScore(player, "telekinesis.psy_energy", Math.floor(calculateEnergyConsumption(energyMax, playerLevel, requiredLevel) * movementFactor))
                    if (palladium.scoreboard.getScore(player, "telekinesis.psy_energy") <= 0) palladium.scoreboard.setScore(player, "telekinesis.psy_energy", -1)

                } else {
                    target.playSound('minecraft:ui.toast.in', 2, 2)
                    global.playSoundLocal(player, 'minecraft:block.enchantment_table.use', "players", 0.5, 1.5);
                }

                
                if (f_Block_Targ) {
                    target.kill();  
                    setGlowGrav(f_Block_Targ, false);  
                } else {
                    
                    setGlowGrav(target, false);  
                }
            }
            
            dataReset(player);
        })
})

function entityTarget(player, r_Entity, entityLevel) {
    r_Entity.playSound('minecraft:ui.toast.in', 2, 2)
    global.playSoundLocal(player, 'minecraft:block.enchantment_table.use', "players", 0.5, 1.5);
    player.persistentData.telekinesisTarget = r_Entity.uuid.toString();
    player.persistentData.telekinesisRequiredLevel = entityLevel;
    player.persistentData.telekinesisBlockTarget = "";
    r_Entity.persistentData.telekinesisTargetedBy = player.uuid.toString();
    let entityTeam = r_Entity.teamId
    if (entityTeam && entityTeam != "telekinesis") {
        r_Entity.persistentData.telekinesisOldTeam = entityTeam;
    }
}

function creatBlock(player, r_Block, blockLevel) {
    let { properties: r_BlockProp, entityData } = r_Block;
    const r_BlockItems = entityData?.Items;
    const beeData = entityData?.Bees; 
    const a_Stand = player.block.createEntity("minecraft:armor_stand");
    const f_Block = player.block.createEntity("minecraft:falling_block");

    let r_BlockId = r_Block?.id;

    
    if (r_BlockItems || beeData) {
        let tileEntityData = {};

        
        if (r_Block.hasTag(chest)) {
            tileEntityData.attachments = [{ items: r_BlockItems }];
        } else {
            if (r_BlockItems) tileEntityData.Items = r_BlockItems; 
            if (beeData) tileEntityData.Bees = beeData; 
        }

        
        f_Block.mergeNbt({ TileEntityData: tileEntityData });
    }

    
    if (r_BlockProp) {
        r_BlockProp.lit = false;  
        r_BlockProp.has_record = false;  
    }

    
    if (r_Block.hasTag(chest)) r_BlockId = idSwap(r_BlockId);

    
    let glowingValue = global.telekinesisConfig.generalGlowingEffect ? 1 : 0;

    
    f_Block.mergeNbt({
        BlockState: { Name: `${r_BlockId}`, Properties: r_BlockProp },
        Glowing: glowingValue,
        NoGravity: 1,
        DropItem: 1,
        Tags: ["psyco_block"]
    });

    a_Stand.mergeNbt({
        Small: 1,
        NoGravity: 1,
        Invisible: 1,
        Invulnerable: 1,
        Marker: 1,
        Tags: ["psyco_stand"]
    });

    
    const position = { x: r_Block.x + 0.5, y: r_Block.y, z: r_Block.z + 0.5 };
    a_Stand.setPosition(position.x, position.y, position.z);
    f_Block.setPosition(position.x, position.y, position.z);
    f_Block.startRiding(a_Stand);
    a_Stand.spawn();
    f_Block.spawn();

    
    f_Block.playSound('minecraft:entity.item.pickup', 1, 1);
    global.playSoundLocal(player, 'minecraft:block.enchantment_table.use', "players", 0.5, 1.5);

    
    const pos = r_Block.pos;
    r_Block.set("minecraft:air");

    if (r_BlockItems) {
        let itemsInArea = player.level.getEntitiesWithin(
            AABB.of(pos.x, pos.y, pos.z, pos.x + 1, pos.y + 1, pos.z + 1)
        ).filter(entity => entity.type == "minecraft:item" && entity.age <= 1);
        itemsInArea.forEach(item => item.kill());
    }

    player.persistentData.telekinesisTarget = a_Stand.uuid.toString();
    player.persistentData.telekinesisBlockTarget = f_Block.uuid.toString();
    player.persistentData.telekinesisRequiredLevel = blockLevel;
    a_Stand.persistentData.telekinesisTargetedBy = player.uuid.toString();
    f_Block.persistentData.telekinesisTargetedBy = player.uuid.toString();
}


function doMotion(player, target, f_Block_Targ) {
    
    const { persistentData: { psyco_scroll: distance }, level: world, yaw, pitch, x: playerX, y: playerY, z: playerZ } = player;

    
    const worldBlock = world.getBlock.bind(world);

    
    let { x, y, z } = calculateViewXYZ(pitch, yaw);

    
    let i_ = 0;

    
    for (let i = 0; i <= distance; i++) {
        
        let Block = worldBlock(Math.floor(playerX + (x * i)), Math.floor(playerY + (y * i) + 1.3), Math.floor(playerZ + (z * i)));

        
        if (Block.hasTag(nonsolid)) i_ = i;
        
        else break;
    }

    player.persistentData.psyco_scroll = i_
    
    let alignedCoordinates = alignCoordinates(world, x * i_ + playerX, y * i_ + playerY + 1.3, z * i_ + playerZ);
    x = alignedCoordinates.x;
    y = alignedCoordinates.y;
    z = alignedCoordinates.z;

    
    let targetLoc = Vec3d(target.x - x, target.y - y, target.z - z).scale(-1);

    
    if (f_Block_Targ != null) {
        
        if (player.isCrouching()) {
            x = Math.floor(x) + 0.5;  
            y = Math.floor(y) + 0.01; 
            z = Math.floor(z) + 0.5;  
        }

        if (global.telekinesisConfig.hidenEntityGlowingEffect && global.telekinesisConfig.generalGlowingEffect) {
            let entityHiden = rayTrace(player, 10, 1).entity;
            if (entityHiden && distanceBetween(player, entityHiden) > distanceBetween(player, f_Block_Targ) + 0.5) {

                if (!entityHiden.tags.contains("telekinesis_boost_toggle") && !!!entityHiden.persistentData.telekinesisTargetedBy) {
                    entityHiden.setGlowing(true)
                    entityHiden.persistentData.telekinesisEntityHidenBy = player.uuid.toString();
                }

                player.persistentData.telekinesisEntityHiden = entityHiden.uuid.toString();
                f_Block_Targ.setGlowing(false)

            } else {
                player.persistentData.telekinesisEntityHiden = "";
                f_Block_Targ.setGlowing(true)
            }
        }

        
        target.teleportTo(world.dimension, x, y, z, 0, 0);

        
        if (distance <= 0) {
            let f_BlockId = f_Block_Targ.nbt.BlockState.Name;  

            
            if (f_BlockId.includes("telekinesis")) f_BlockId = idSwap(f_BlockId);

            let r_BlockItems = null

            
            if (f_Block_Targ.nbt?.TileEntityData?.attachments) r_BlockItems = f_Block_Targ.nbt.TileEntityData.attachments[0]["items"];
            if (f_Block_Targ.nbt?.TileEntityData?.Items) r_BlockItems = f_Block_Targ.nbt.TileEntityData.Items;

            
            if (r_BlockItems) {
                r_BlockItems.forEach(itemNbt => {
                    const e_item = player.block.createEntity("minecraft:item");
                    e_item.setNbt({ Item: itemNbt });
                    e_item.setPosition(playerX, playerY, playerZ);
                    e_item.spawn(); 
                });
            }

            
            if (f_Block_Targ.nbt?.TileEntityData?.Bees || f_Block_Targ.nbt?.BlockState?.Properties?.honey_level) {
                let beeData = f_Block_Targ.nbt.TileEntityData.Bees;
                let honeyLevel = f_Block_Targ.nbt?.BlockState?.Properties?.honey_level || "0"; 
                let beeItem = Item.of(f_BlockId);
                beeItem.setNbt({
                    BlockStateTag: {
                        honey_level: honeyLevel, 
                    },
                    BlockEntityTag: {
                        Bees: beeData, 
                    },
                });
                player.give(beeItem);
            }
            else if (f_Block_Targ.nbt?.BlockState?.Properties?.type == "double") {
                player.give(Item.of(f_BlockId, 2)); 
            } else if (f_Block_Targ.nbt?.BlockState?.Properties?.candles) {
                let candles = parseInt(f_Block_Targ.nbt.BlockState.Properties.candles, 10);
                player.give(Item.of(f_BlockId, candles)); 
            } else if (f_Block_Targ.nbt?.BlockState?.Properties?.eggs) {
                let eggs = parseInt(f_Block_Targ.nbt.BlockState.Properties.eggs, 10);
                player.give(Item.of(f_BlockId, eggs)); 
            } else if (f_Block_Targ.nbt?.BlockState?.Properties?.pickles) {
                let pickles = parseInt(f_Block_Targ.nbt.BlockState.Properties.pickles, 10);
                player.give(Item.of(f_BlockId, pickles)); 
            } else {
                player.give(f_BlockId); 
            }
            
            f_Block_Targ.kill();
            
            target.kill();
        }
    } else {
        
        if (target.type == "minecraft:item") {
            target.mergeNbt({ NoAI: 1 });
        }
        
        else if (target instanceof $Projectile) {
            target.mergeNbt({ NoAI: 1, inGround: 0, life: 0 });
            target.setMotion(target.motionX / 100, target.motionY / 100, target.motionZ / 100);
        }

        
        target.resetFallDistance();
        if (target.isPlayer()) {
            let clearPosition = findClearPosition(world, x, y, z);
            if (clearPosition) {
                
                let dx = player.x - target.x;
                let dy = player.y + player.eyeHeight - (target.y + target.eyeHeight); 
                let dz = player.z - target.z;

                
                let invYaw = Math.atan2(-dx, dz) * (180 / JavaMath.PI); 
                let dist = Math.sqrt(dx * dx + dz * dz); 
                let invPitch = Math.atan2(-dy, dist) * (180 / JavaMath.PI); 

                target.teleportTo(world.dimension, clearPosition.x, clearPosition.y, clearPosition.z, invYaw, invPitch);
            } else target.teleportTo(world.dimension, target.x, target.y, target.z, target.yaw, target.pitch);
            if (target.isCrouching()){
                target.persistentData.telekinesisCrouching = (target.persistentData.telekinesisCrouching || 0) + 1;
                if(target.persistentData.telekinesisCrouching >=10) dataReset(player);
            }else target.persistentData.remove("telekinesisCrouching")
        } else target.setDeltaMovement(targetLoc);
    }
}

function calculateViewXYZ(p_pitch, p_yaw) {
    const x_rad = p_pitch * JavaMath.PI / 180;
    const y_rad = p_yaw * JavaMath.PI / 180;

    const dirV = {
        x: -Math.sin(y_rad) * Math.cos(x_rad),
        y: -Math.sin(x_rad),
        z: Math.cos(y_rad) * Math.cos(x_rad)
    };

    
    return {
        x: Math.round(dirV.x * 100) / 100,
        y: Math.round(dirV.y * 100) / 100,
        z: Math.round(dirV.z * 100) / 100
    };
}

function setGlowGrav(entity, bool) {
    entity.setNoGravity(bool)
    if (global.telekinesisConfig.generalGlowingEffect) entity.setGlowing(bool)
}

function dataReset(player) {
    player.tags.remove("psyco_toggle")
    player.persistentData.telekinesisTarget = ""
    player.persistentData.telekinesisBlockTarget = ""
    player.persistentData.telekinesisRequiredLevel = ""
    player.persistentData.telekinesisEntityHiden = ""
    player.persistentData.psyco_scroll = 3
}

function idSwap(id) {
    if (id.includes("minecraft:")) return id = id.replace("minecraft:", "telekinesis:f_")
    if (id.includes("telekinesis:f_")) return id = id.replace("telekinesis:f_", "minecraft:")
    return id
}

function rayTrace(entity, distance, inflate) {
    let level = entity.level
    let eyePos = entity.eyePosition
    let viewVec = entity.getViewVector(1)
    let endPos = eyePos.add(viewVec.x() * distance, viewVec.y() * distance, viewVec.z() * distance)
    let aabb = AABB.of(eyePos.x(), eyePos.y(), eyePos.z(), endPos.x(), endPos.y(), endPos.z())

    let ray = null;
    if (inflate == 0) {
        ray = $ProjectileUtil.getEntityHitResult(level, entity, eyePos, endPos, aabb, (e) => {
            return !e.isSpectator() && !e.tags.contains("psyco_block") && !e.tags.contains("psyco_stand")
        }, 0)
    } else {
        ray = $ProjectileUtil.getEntityHitResult(level, entity, eyePos, endPos, aabb.inflate(inflate), (e) => {
            return !e.isSpectator() && !e.tags.contains("psyco_block") && !e.tags.contains("psyco_stand")
        })
    }

    let clip = new $ClipContext(
        entity.getEyePosition(1),
        entity.getEyePosition(1).add(entity.getLookAngle().scale(distance)),
        'collider', 'none',
        entity
    )
    let hit = level.clip(clip)

    if (ray == null) {
        return {
            block: hit.getBlockPos() ? level.getBlock(hit.getBlockPos()) : null,
            entity: null
        }
    }
    if (entity.block.pos.distToCenterSqr(ray.entity.x, ray.entity.y, ray.entity.z) > entity.block.pos.distToCenterSqr(hit.getBlockPos().x, hit.getBlockPos().y, hit.getBlockPos().z)) {
        return {
            block: hit.getBlockPos() ? level.getBlock(hit.getBlockPos()) : null,
            entity: null
        }
    }
    return {
        block: level.getBlock(hit.getBlockPos()),
        entity: ray.entity
    }
}

function getEntityByUUID(uuid) {
    let entities = Utils.server.getEntities()
    for (let i = 0; i < entities.size(); i++) {
        if (entities.get(i).uuid == uuid) {
            return entities.get(i)
        }
    }
}


function isNonSolidBlock(world, x, y, z) {
    return !world.getBlock(Math.floor(x), Math.floor(y), Math.floor(z)).hasTag(nonsolid);
}

function alignCoordinates(world, x_, y_, z_) {

    
    const align_ax = isNonSolidBlock(world, x_ + 0.5, y_, z_) || isNonSolidBlock(world, x_ - 0.5, y_, z_);
    const align_az = isNonSolidBlock(world, x_, y_, z_ + 0.5) || isNonSolidBlock(world, x_, y_, z_ - 0.5);
    const align_ay = isNonSolidBlock(world, x_, y_ + 0.5, z_) || isNonSolidBlock(world, x_, y_ - 0.5, z_);

    
    if (align_ax && !align_ay && !align_az) {
        x_ = Math.floor(x_) + 0.5;
    }
    if (align_ay && !align_ax && !align_az) {
        y_ = Math.floor(y_) + 0.01;
    }
    if (align_az && !align_ay && !align_ax) {
        z_ = Math.floor(z_) + 0.5;
    }
    if (align_ax && align_ay && !align_az) {
        x_ = Math.floor(x_) + 0.5;
        y_ = Math.floor(y_) + 0.01;
    }
    if (align_az && align_ax && !align_ay) {
        x_ = Math.floor(x_) + 0.5;
        z_ = Math.floor(z_) + 0.5;
    }
    if (align_az && align_ay && !align_ax) {
        y_ = Math.floor(y_) + 0.01;
        z_ = Math.floor(z_) + 0.5;
    }
    if (align_az && align_ay && align_ax) {
        x_ = Math.floor(x_) + 0.5;
        y_ = Math.floor(y_) + 0.01;
        z_ = Math.floor(z_) + 0.5;
    }

    
    return { x: x_, y: y_, z: z_ };
}

function calculerForce(distance) {
    
    distance = Math.max(1, Math.min(6, distance));

    
    const forceMax = 1.8; 
    const forceMin = 0.5; 
    const distanceMax = 6; 
    const distanceMin = 1; 

    
    const force = forceMax - (distance - distanceMin) * (forceMax - forceMin) / (distanceMax - distanceMin);

    return force;
}

function calculateEnergyConsumption(maxEnergy, playerLevel, blockLevel) {
    
    const basePercentage = 0.10; 
    const energyConsumption = maxEnergy * basePercentage * (blockLevel / playerLevel);

    return energyConsumption;
}

function distanceBetween(player, entity) {
    const dx = entity.x - player.x;
    const dy = entity.y - player.eyeY;
    const dz = entity.z - player.z;

    
    const distance = Math.sqrt(((dx) ** 2) + ((dy) ** 2) + ((dz) ** 2));

    return distance;
}


function findClearPosition(world, x, y, z) {

    
    if (isSpaceClear(world, x, y, z) && isSpaceClear(world, x, y + 1, z)) {
        return { x: x, y: y, z: z };
    }

    
    for (let offsetY = -0.1; offsetY >= -1; offsetY -= 0.1) { 
        if (isSpaceClear(world, x, y + offsetY, z) && isSpaceClear(world, x, y + offsetY + 1, z)) {
            return { x: x, y: y + offsetY, z: z }; 
        }
    }

    
    for (let offsetY = 0.1; offsetY <= 0.5; offsetY += 0.1) { 
        if (isSpaceClear(world, x, y + offsetY, z) && isSpaceClear(world, x, y + offsetY + 1, z)) {
            return { x: x, y: y + offsetY, z: z }; 
        }
    }

    
    return null; 
}

function isSpaceClear(world, x, y, z) {
    const offsets = [
        [0, 0], [0.5, 0], [-0.5, 0], [0, 0.5], [0, -0.5],
        [0.5, 0.5], [0.5, -0.5], [-0.5, 0.5], [-0.5, -0.5]
    ];

    for (const [dx, dz] of offsets) {
        
        if (isSolidBlock(world, x + dx, y, z + dz)) {
            return false; 
        }
        
        if (isSolidBlock(world, x + dx, y + 0.8, z + dz)) { 
            return false; 
        }
    }

    return true; 
}

function isSolidBlock(world, x, y, z) {
    
    return isNonSolidBlock(world, Math.floor(x), Math.floor(y), Math.floor(z));
}