let $AbilityBarRenderer = Java.loadClass('net.threetag.palladium.client.screen.AbilityBarRenderer');
let $ChatScreen = Java.loadClass('net.minecraft.client.gui.screens.ChatScreen');
let $PalladiumConfig = Java.loadClass('net.threetag.palladium.PalladiumConfig');
let isDebugScreen = false;

PalladiumEvents.registerGuiOverlays((event) => {
    
    event.register(
        'telekinesis:xp_display',  
        (minecraft, gui, poseStack, partialTick, screenWidth, screenHeight) => {
            const player = minecraft.player;
            let selectedPower = $AbilityBarRenderer.ABILITY_LISTS[$AbilityBarRenderer.SELECTED]?.power;
            let position = $PalladiumConfig.Client.ABILITY_BAR_POSITION.get().name();

            if (selectedPower && selectedPower.getId() === 'telekinesis:telekinesis') {
                
                let psycoLevel = palladium.scoreboard.getScore(player, "telekinesis.psy_level", 1);
                let psycoXp = palladium.scoreboard.getScore(player, "telekinesis.psy_xp", 1);
                let psycoXpMax = palladium.scoreboard.getScore(player, "telekinesis.psy_xp_max", 1);

                
                let hasBoost = player.stages.has("telekinesis.boost.toggle");
                let showBoost01 = hasBoost && (!player.isCrouching() || !player.onGround());

                
                let xpPercentage = Math.min(1, psycoXp / psycoXpMax); 
                let xpBarWidth = Math.floor(96 * xpPercentage); 

                
                let isChatOpen = minecraft.screen && minecraft.screen instanceof $ChatScreen;

                
                let renderBoostIcon = (x, y) => {
                    if (showBoost01) {
                        poseStack.pose().pushPose();
                        poseStack.pose().translate(0, 0, 1);
                        poseStack.blit('palladium:textures/gui/ability_bar.png', x, y, 42, 56, 18, 18, 256, 256);
                        let iconPath = 'telekinesis:textures/icon/boost.png';
                        poseStack.blit(iconPath, x + 1, y + 1, 0, 0, 16, 16, 16, 16);
                        poseStack.pose().popPose();
                    }
                };

                if (selectedPower && selectedPower.getId() === 'telekinesis:telekinesis') {
                    drawXpDisplay(
                        poseStack,
                        guiUtil,
                        screenWidth,
                        screenHeight,
                        position, 
                        isChatOpen, 
                        psycoLevel, 
                        xpBarWidth, 
                        renderBoostIcon,
                        player 
                    );
                }

            }
        }
    );
});

PalladiumEvents.registerGuiOverlays((event) => {
    event.register(
        'telekinesis:player_display',
        (minecraft, gui, poseStack, partialTick, screenWidth, screenHeight) => {
            const player = minecraft.player;
            let selectedPower = $AbilityBarRenderer.ABILITY_LISTS[$AbilityBarRenderer.SELECTED]?.power;

            if (selectedPower && selectedPower.getId() === 'telekinesis:telekinesis') {
                let isChatOpen = minecraft.screen && minecraft.screen instanceof $ChatScreen;

                
                let position = $PalladiumConfig.Client.ABILITY_BAR_POSITION.get().name();

                if (minecraft.level) {
                    let entities = minecraft.level.entities;

                    
                    let nearbyEntities = entities.filter(entity => {
                        let nameToStage = entity.username.toLowerCase().replace(/_/g, ".")
                        let slot4 = "slot4" + nameToStage
                        let slot5 = "slot5" + nameToStage
                        return entity.type == "minecraft:player" && entity.username != player.username && (player.stages.has(slot4) || player.stages.has(slot5));
                    });

                    
                    let slotOffsets = {
                        1: { offsetFromSide: -6, offsetFromBottom: 109, offsetFromTop: 21 },  
                        2: { offsetFromSide: -6, offsetFromBottom: 87, offsetFromTop: 43 },   
                        3: { offsetFromSide: -6, offsetFromBottom: 65, offsetFromTop: 65 },   
                        4: { offsetFromSide: -6, offsetFromBottom: 43, offsetFromTop: 87 },   
                        5: { offsetFromSide: -6, offsetFromBottom: 21, offsetFromTop: 109 },  
                    };

                    nearbyEntities.forEach((entity) => {
                        let nameToStage = entity.username.toLowerCase().replace(/_/g, ".")
                        let slot4 = "slot4" + nameToStage
                        let slot5 = "slot5" + nameToStage
                        let slotIndex = 4;
                        let actviated = false
                        if (player.stages.has(slot4)) {
                            slotIndex = 4
                            actviated = player.stages.has("telekinesis.boost.sharing.slot4");
                        }
                        if (player.stages.has(slot5)) {
                            slotIndex = 5
                            actviated = player.stages.has("telekinesis.boost.sharing.slot5");
                        }

                        let skinTexture = minecraft.getSkinManager().getInsecureSkinLocation(entity.getGameProfile());
                        if (skinTexture) {
                            const scaleValue = 2;
                            const originalSize = 8;
                            const targetSize = 18;

                            drawInSlot(
                                poseStack,
                                screenWidth,
                                screenHeight,
                                position, 
                                slotIndex, 
                                slotOffsets,
                                skinTexture,
                                scaleValue,
                                originalSize,
                                targetSize,
                                isChatOpen,
                                actviated,
                                player 
                            );
                        }
                    });
                }
            }
        }
    );
});

function drawInSlot(poseStack, screenWidth, screenHeight, position, slotIndex, slotOffsets, texture, scaleValue, originalSize, targetSize, isChatOpen, actviated, player) {

    if (position === 'HIDDEN') return;
    if (position === 'TOP_LEFT' && isDebugScreen) return;
    if (position === 'TOP_RIGHT' && isDebugScreen) return;

    const { offsetFromSide, offsetFromBottom, offsetFromTop } = slotOffsets[slotIndex];
    const internalOffset = (targetSize - originalSize) / 2;

    
    let xPosition = screenWidth - (targetSize * scaleValue) - offsetFromSide;
    let yPosition = screenHeight - (targetSize * scaleValue) - offsetFromBottom;

    let sharingOn = player.stages.has("telekinesis.boost.sharing");

    
    switch (position) {
        case 'TOP_LEFT':
            xPosition = offsetFromSide; 
            yPosition = offsetFromTop;  
            break;

        case 'TOP_RIGHT':
            yPosition = offsetFromTop; 
            break;

        case 'BOTTOM_LEFT':
            xPosition = offsetFromSide; 
            yPosition = isChatOpen ? offsetFromTop : yPosition; 
            break;

        case 'BOTTOM_RIGHT':
            yPosition = isChatOpen ? offsetFromTop : yPosition; 
            break;

        default:
            console.warn(`Position "${position}" non reconnue. Utilisation de BOTTOM_RIGHT par défaut.`);
            yPosition = isChatOpen ? offsetFromTop : yPosition; 
            break;
    }

    
    poseStack.pose().pushPose();
    poseStack.pose().translate(xPosition, yPosition, 1);
    if (actviated) poseStack.blit('telekinesis:textures/gui/head_boost.png', (targetSize - originalSize) - 1, (targetSize - originalSize) - 1, 0, 0, 18, 18, 18, 18);
    
    poseStack.pose().scale(scaleValue, scaleValue, scaleValue);

    
    poseStack.blit(texture.toString(), internalOffset, internalOffset, 8, 8, originalSize, originalSize, 64, 64);
    poseStack.blit(texture.toString(), internalOffset, internalOffset, 40, 8, originalSize, originalSize, 64, 64);
    poseStack.pose().popPose();

    if (player.isCrouching() && player.onGround() && !actviated && !sharingOn) {
        poseStack.pose().pushPose();
        poseStack.pose().translate(xPosition, yPosition, 1);
        poseStack.blit('telekinesis:textures/gui/nop.png', (targetSize - originalSize) - 1, (targetSize - originalSize) - 1, 0, 0, 18, 18, 18, 18);
        poseStack.pose().popPose();
    }
}

function drawXpDisplay(poseStack, guiUtil, screenWidth, screenHeight, position, isChatOpen, psycoLevel, xpBarWidth, renderBoostIcon, player) {
    
    let xPosition = screenWidth - 51; 
    let yPosition = screenHeight - 36; 
    let barX = screenWidth * 2 - 104; 
    let barY = screenHeight * 2 - 56; 
    let boostIconX = screenWidth - 21; 
    let boostIconY = screenHeight - 92; 
    let xpBarTexture = 'telekinesis:textures/gui/xp_bar.png'; 

    if (position === 'HIDDEN') return;
    if (position === 'TOP_LEFT' && isDebugScreen) return;
    if (position === 'TOP_RIGHT' && isDebugScreen) return;

    
    switch (position) {
        case 'TOP_LEFT':
            xPosition = 34; 
            yPosition = 29;
            barX = 0;
            barY = 46;
            boostIconX = 3;
            boostIconY = 74;
            xpBarTexture = 'telekinesis:textures/gui/xp_bar_invert_left.png'; 
            break;

        case 'TOP_RIGHT':
            yPosition = 29;
            barY = 46;
            boostIconY = 74;
            xpBarTexture = 'telekinesis:textures/gui/xp_bar_invert.png';
            break;

        case 'BOTTOM_LEFT':
            xPosition = 34; 
            yPosition = isChatOpen ? 29 : screenHeight - 36;
            barX = 0; 
            barY = isChatOpen ? 46 : screenHeight * 2 - 56;
            boostIconX = 3;
            boostIconY = isChatOpen ? 74 : screenHeight - 92;
            xpBarTexture = isChatOpen
                ? 'telekinesis:textures/gui/xp_bar_invert_left.png' 
                : 'telekinesis:textures/gui/xp_bar_left.png'; 
            break;

        case 'BOTTOM_RIGHT':
            yPosition = isChatOpen ? 29 : screenHeight - 36;
            barY = isChatOpen ? 46 : screenHeight * 2 - 56;
            boostIconY = isChatOpen ? 74 : screenHeight - 92;
            xpBarTexture = isChatOpen
                ? 'telekinesis:textures/gui/xp_bar_invert.png' 
                : 'telekinesis:textures/gui/xp_bar.png'; 
            break;

        default:
            console.warn(`Position "${position}" non reconnue. Utilisation de BOTTOM_RIGHT par défaut.`);
            yPosition = isChatOpen ? 29 : screenHeight - 36;
            barY = isChatOpen ? 46 : screenHeight * 2 - 56;
            boostIconY = isChatOpen ? 74 : screenHeight - 92;
            xpBarTexture = isChatOpen
                ? 'telekinesis:textures/gui/xp_bar_invert.png' 
                : 'telekinesis:textures/gui/xp_bar.png'; 
            break;
    }

    
    guiUtil.drawString(poseStack, Component.string("Lv" + psycoLevel), xPosition, yPosition, 0xe300cc);

    
    if(psycoLevel < 9){
        poseStack.pose().pushPose();
        poseStack.pose().translate(0, 0, 1);
        poseStack.pose().scale(0.5, 0.5, 1); 
        poseStack.blit(xpBarTexture, barX, barY, 0, 0, 104, 10, 104, 12); 
        poseStack.blit(xpBarTexture, barX + 4, barY + 4, 4, 10, xpBarWidth, 2, 104, 12); 
        poseStack.pose().popPose();
    }

    
    renderBoostIcon(boostIconX, boostIconY);

    let sharingOn = player.stages.has("telekinesis.boost.sharing");
    let selected = player.stages.has("telekinesis.sharing.scroll.4") ? 4 :
        player.stages.has("telekinesis.sharing.scroll.5") ? 5 : null;

    poseStack.pose().pushPose();
    poseStack.pose().translate(0, 0, 1);
    poseStack.blit('palladium:textures/gui/ability_bar.png', boostIconX, boostIconY + 22, 60, 56, 18, 18, 256, 256);
    poseStack.blit('palladium:textures/gui/ability_bar.png', boostIconX, boostIconY + 44, 60, 56, 18, 18, 256, 256);
    poseStack.pose().popPose();

    if (selected && sharingOn) {
        poseStack.pose().pushPose();
        poseStack.pose().translate(0, 0, 1);
        let selectedY = selected === 4 ? boostIconY + 20 : selected === 5 ? boostIconY + 42 : null;
        poseStack.blit('palladium:textures/gui/ability_bar.png', boostIconX - 2, selectedY, 105, 49, 22, 22, 256, 256);
        poseStack.pose().popPose();
    }
}


ClientEvents.leftDebugInfo(event => {
    Client.scheduleInTicks(1, () => {
        isDebugScreen = false;
    });
    isDebugScreen = true;
})

