const interactible = "telekinesis:interactible";

BlockEvents.rightClicked(event => {
    
    const { player, block, item } = event;
    const tags = player.tags;  
    if (player.isCrouching() && !player.offHandItem.isEmpty) {
        event.cancel();
    }
    
    if (player.isCrouching() && block.hasTag(interactible) && item.empty && abilityUtil.isEnabled(player, "telekinesis:telekinesis", "psyco_active")) {
        
        if (!tags.contains("psyco_toggle")) {
            tags.add("psyco_toggle");  
            event.cancel();  
        }
    }
});

ItemEvents.entityInteracted(event => {
    
    const { player, target } = event;
    const tags = player.tags;  

    
    if (player.mainHandItem.isEmpty() && abilityUtil.isEnabled(player, "telekinesis:telekinesis", "psyco_active")) {
        
        if (!tags.contains("psyco_toggle")) {
            tags.add("psyco_toggle");  
            event.cancel();  
        }
        
        else if (tags.contains("psyco_toggle")) {
            tags.remove("psyco_toggle");  
            event.cancel();  
        }
    } else if (player.mainHandItem.isEmpty() &&
        player.tags.contains("telekinesis_boost_sharing_toggle") && player.tags.contains("telekinesis_boost_sharing_raytrace")) {
        if (target.isPlayer()) {
            global.playSoundLocal(player, 'minecraft:block.enchantment_table.use', "players", 0.5, 1.5);
            let slotValue = player.persistentData.sharing_scroll
            let nameToStage = target.username.toLowerCase().replace(/_/g, ".")
            let slot4 = "slot4" + nameToStage
            let slot5 = "slot5" + nameToStage
            if (player.stages.has(slot4)) {
                player.stages.remove(slot4)
                player.tags.remove("telekinesis_sharing_slot4")
                player.persistentData.telekinesisBoostSharingSlot4 = ""
                player.persistentData.telekinesisBoostSharingSlot4Name = ""
            }
            if (player.stages.has(slot5)) {
                player.stages.remove(slot5)
                player.tags.remove("telekinesis_sharing_slot5")
                player.persistentData.telekinesisBoostSharingSlot5 = ""
                player.persistentData.telekinesisBoostSharingSlot5Name = ""
            }
            if (slotValue == 4) {
                player.persistentData.telekinesisBoostSharingSlot4 = target.uuid.toString()
                player.persistentData.telekinesisBoostSharingSlot4Name = target.username
            }
            if (slotValue == 5) {
                player.persistentData.telekinesisBoostSharingSlot5 = target.uuid.toString()
                player.persistentData.telekinesisBoostSharingSlot5Name = target.username
            }
            let stage = "slot" + slotValue + target.username.toLowerCase().replace(/_/g, ".")
            player.stages.add(stage)
            player.tags.add("telekinesis_sharing_slot" + slotValue)
        }
    }
});

BlockEvents.placed(event => {
    const { player } = event;
    const tags = player.tags;
    if (player.mainHandItem.isEmpty()) {
        if (!tags.contains("psyco_toggle")) {
            tags.add("psyco_toggle");  
        }
    }
});

const attributes = {
    fly: { id: "palladium:levitation_speed", uuid: "8214453b-56ff-42d6-bb10-2af705a5b53c", minLevel: 6, maxLevel: 9, cap: 1.0 },
    armor: { id: "minecraft:generic.armor", uuid: "8e8d9ddb-a885-4f11-8bf8-4935f5b9b224", minLevel: 4, maxLevel: 9, cap: 10 },
    damage: { id: "minecraft:generic.attack_damage", uuid: "71a9d77e-8f23-4888-a634-fd05b6cc0761", minLevel: 4, maxLevel: 9, cap: 4 },
    speed: { id: "minecraft:generic.movement_speed", uuid: "296d32fa-6bd3-40f4-a70f-d45834541e2f", minLevel: 5, maxLevel: 9, cap: 0.05 },
};